/**
 * File: js-native-classes
 *
 * This file represents documentation of native JS classes, for reference linking by other files in documentations.
 * In general you can ignore this file.
 *
 */

/**
 * @class Object
 * Native javascript object, while this can mean anything in JS. You probably should not be using a string/numeric/array type here. 
 *
 * See: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object 
 *
 */

/**
 * @class String
 * Native javascript String. 
 *
 * See: https://developer.mozilla.org/en/docs/Web/JavaScript/Reference/Global_Objects/String
 *
 */

/**
 * @class Boolean
 * Native javascript Boolean, basically TRUE or FALSE. 
 *
 * See: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean
 *
 */

/**
 * @class Function
 * Native javascript Function object, that is executable, hopefully without exceptions.
 *
 * See: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function
 *
 */

/**
 * @class Number
 * Native javascript Number object.
 *
 * See: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number
 *
 */

/**
 * @class Int
 * Native javascript Number. But this time you probably shold limit it to a whole number.
 *
 * See: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number
 *
 */